cmake_minimum_required(VERSION 3.28 FATAL_ERROR)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

project(IAEngine)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    message(STATUS "Configuring IAEngine for Debug..")
    add_compile_definitions("__IA_DEBUG=1")
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
    message(STATUS "Configuring IAEngine for Release..")
    add_compile_options(-O3)
    add_compile_definitions("__IA_DEBUG=0")
else()
    message(FATAL_ERROR "Unknwon CMAKE_BUILD_TYPE \"${CMAKE_BUILD_TYPE}\"")
endif()

add_subdirectory(Vendor/)

add_subdirectory(Engine/)
add_subdirectory(CLI/)


